without type_check
without warning

include graphics.e
include image.e

constant minimum_fire = 20
constant bal = {"00",
                "",
                "",
                "00"}

sequence fire, screen
integer fx, fy, fw, fh

procedure setpal()
sequence a
atom m
for x = minimum_fire to 255 do
    m = x * x / 200
    if m > 63 then m = 63 end if
    a = palette(x, {m, x / 4, 0})
end for
for x = 0 to minimum_fire do
    a = palette(x, {0, 0, 0})
end for
end procedure

procedure draw_bal()
 integer x, y
 x = rand(fw - 5)
 y = rand(fh - 5)
 for a = 1 to length(bal) do
   for b = 1 to length(bal[a]) do
     screen[y+a][x+b] = bal[a][b]
   end for
 end for
end procedure

procedure create_screen(integer x, integer y, integer w, integer h)
  if x < 0 then x = 0 end if
  if w > 320 then w = 320 end if
  if x + w > 320 then w = 320 - x end if
  if y < 0 then y = 0 end if
  if h > 199 then h = 0 end if
  if y + h > 199 then h = 199 - y end if
  screen = {}
  for a = 1 to h do
      screen = screen & {repeat(255, w + 2)}
      screen[a][1] = 0
      screen[a][2] = 0
      screen[a][w+1] = 0
      screen[a][w+2] = 0
  end for
  fx = x
  fy = y
  fw = w
  fh = h
end procedure

procedure start_burn()
  atom color
  color = 0
  for ay = 1 to length(screen) - 1 do
  for ax = 2 to length(screen[ay]) - 1 do
    if (screen[ay+1][ax] > minimum_fire) then
       if screen[ay][ax] = 0 then screen[ay][ax] = 1 end if
       color = (screen[ay+1][ax-1] + screen[ay+1][ax] + screen[ay+1][ax+1] + rand(screen[ay][ax]) + screen[ay][ax]) / 5
       screen[ay][ax] = color
    else
       screen[ay][ax] = 0
    end if
  end for
  end for
  display_image({fx, fy}, screen)
end procedure

puts(1, "Hi this is the second graphics tutorial by DJ D from Quarter Moon!\n")
puts(1, "This one is about the fire-effect. I added also some little explosions to\n")
puts(1, "go up in flames.\n\n")
puts(1, "If you have any questions, please mail me at: QMSoft@webmail.net\n")
puts(1, "\nPress a key to continue...")
while get_key() = -1 do
end while

if graphics_mode(19) then
  abort(1)
end if
setpal()
create_screen(100, 150, 120, 49)
while get_key() = -1 do
  start_burn()
  if rand(10) = 5 then draw_bal() end if
end while
if graphics_mode(-1) then
end if
