without type_check
without warning

include graphics.e

constant zoomlevel = 4

sequence plasma_field, CosTab
atom mov1, mov2, mov3, mov4, origx, origy

type graphics_point(sequence p)
    return length(p) = 2 and p[1] >= 0 and p[2] >= 0
end type

function Rad(atom i)
  return(i * 3.14 / 180)
end function

procedure CreateCosTab()
  CosTab = repeat(0, 1021)
  for i = 1 to 1020 do
    CosTab[i] = (cos(Rad((i-1)/360*255*2))*31)+32
  end for
end procedure

procedure CreateColTab()
sequence a
atom m
for x = 1 to 255 do
    m = x * x / 200
    if m > 63 then m = 63 end if
    a = palette(x, {m, x / 4, 0})
end for
end procedure

procedure display_image(graphics_point xy, sequence pixels)
    for i = 1 to length(pixels) do
	pixel(pixels[i], xy)
	xy[2] = xy[2] + 1
    end for
end procedure

procedure DrawPlasma()
  atom t1, t2, t3, t4
  t1 = 0
  t2 = 0
  t3 = 0
  t4 = 0
  mov3 = 0
  mov4 = 200
  mov1 = 0
  mov2 = 255
  for y = 1 to 100 do
      t3 = mov3
      if t3 > 255 then t3 = t3 - 255 end if
      while t3 > 255 do t3 = t3 - 255 end while
      t4 = mov4 + origy
      while t4 > 255 do t4 = t4 - 255 end while
      if t4 <= 0 then t4 = t4 + 255 end if
    for x = 1 to 160 do
      t1 = mov1
      while t1 > 255 do t1 = t1 - 255 end while
      if t1 <= 0 then t1 = t1 + 255 end if
      t2 = mov2 + origx
      while t2 > 255 do t2 = t2 - 255 end while
      if t2 <= 0 then t2 = t2 + 255 end if
      if t1 <= 0 then t1 = 1 end if
      if t2 <= 0 then t2 = 1 end if
      if t3 <= 0 then t3 = 1 end if
      if t4 <= 0 then t4 = 1 end if
      plasma_field[y][x] = CosTab[t1]+CosTab[t2]+CosTab[t3]+CosTab[t4]
      mov1 = mov1 + zoomlevel
      if mov1 > 255 then mov1 = mov1 - 255 end if
      mov2 = mov2 + 1
      if mov2 > 255 then mov2 = mov2 - 255 end if
    end for
    mov3 = mov3 + zoomlevel
    if mov3 > 255 then mov3 = mov3 - 255 end if
    mov4 = mov4 + 1
    if mov4 > 255 then mov4 = mov4 - 255 end if
    mov1 = 0
    mov2 = 255
  end for
  origy = origy + 8
  if origx > 255 then origx = origx - 255 end if
  origx = origx - 8
  if origy <= 0 then origy = origy + 255 end if
  display_image({80, 50}, plasma_field)
end procedure

puts(1, "Hi ya all!\n")
puts(1, "This is the 3th part of the Quarter Moon Trainer Series! This is one on\n")
puts(1, "the plasma - effect. Just for fun I used the palette from the second tutorial\n")
puts(1, "so it's gives a firely look.")
puts(1, "\nHope to have some reactions soon, DJ D\n\nIf you have any question, mail them to QMSoft@webmail.net\n")
puts(1, "\nPress a key to continue...")
while get_key() = -1 do
end while
if graphics_mode(19) then
  abort(1)
end if
CreateCosTab()
CreateColTab()
plasma_field = {}
for y = 1 to 100 do
  plasma_field = plasma_field & {repeat(0, 160)}
end for
origx = 0
origy = 0
while get_key() = -1 do
  DrawPlasma()
end while
if graphics_mode(-1) then
end if
if graphics_mode(3) then
end if
